SystemOrganization addCategory: #'GT-Playground'!

!SequenceableCollection methodsFor: '*GT-Playground' stamp: 'StefanReichhart 3/21/2015 09:52'!
takeFirst: anInteger
	^ self first: (self size min: anInteger)! !

!GLMSystemWindow methodsFor: '*GT-Playground' stamp: 'AndreiChis 9/8/2014 22:56'!
acceptAction: anAction 
	"Be compatible with edit:label:accept:.
	Not the best place for this method.
	Interim situation to move things forward..."
	self flag: #TODO.
	self model ifNotNil: [:aModel | aModel acceptAction: anAction].! !

!GLMSystemWindow methodsFor: '*GT-Playground' stamp: 'AndreiChis 9/8/2014 22:55'!
acceptContents: aString 
	"Be compatible with edit:label:accept:.
	Not the best place for this method.
	Interim situation to move things forward..."
	self flag: #TODO.
	self model ifNotNil: [:aModel | aModel acceptContents: aString].

	! !

!Duration methodsFor: '*GT-Playground' stamp: 'TudorGirba 3/16/2015 07:42'!
gtPlaygroundHumanReadableString
	self < 1 minute ifTrue: [ ^ 'just now' ].
	self < 2 minutes ifTrue: [ ^ '1 minute ago' ].
	self < 1 hour ifTrue: [ ^ self minutes asString , ' minutes ago' ].
	self < 1 day ifTrue: [ ^ self hours asString , ' hours ago' ].
	self < 1 year ifTrue: [ ^ self days asString , ' days ago' ].
	^ self printString! !

GLMCompositePresentation subclass: #GTPlayground
	instanceVariableNames: ''
	classVariableNames: 'GTPlaygroundEnabledStatus PreferredExtent RememberPreferredExtent'
	poolDictionaries: ''
	category: 'GT-Playground'!

!GTPlayground commentStamp: 'TudorGirba 10/22/2014 07:37' prior: 0!
Playground is the correspondent of a classic Smalltalk Workspace. The problem with the name Workspace is that it implies that work should be carried out in this space, while this is not a best practice. Playground describes better the intention of providing a place in which we can quickly play with some code.

The model behind a Playground instance is a PlayPage object.

!!!!Use cases
The Playground can be used in two ways

# As a place to construct and try out code snippets.
# as an entry point into an inspection process.

In both cases, the ability of diving into objects to the right is an important feature.

!!!!Running
[ [ [ 
	self open.
 ] ] ]!

!GTPlayground class methodsFor: 'compatibility-tools' stamp: 'StefanReichhart 3/20/2015 22:04'!
edit: aString label: aLabel

"Open a new playground with the given contents"
"Compatibility with the original Workspace"
"#edit: aText label: labelString accept: anAction"
"	^(Smalltalk tools workspace openLabel: labelString)
		acceptContents:  aText;
		acceptAction: anAction;
		yourself."

"Open an editor on the given string/text"
	| page |
	"self halt"

	page := GTPlayPage new
		saveContent: aString;
		title: aLabel;
		yourself.
		
	self flag: #TODO. "We need to put an equivalent to the acceptAction thing."
	^ self new openOn: page! !

!GTPlayground class methodsFor: 'examples' stamp: 'AndreiChis 1/30/2015 12:28'!
examplePlaygroundWithBindings
	| playground wsBindings |
	wsBindings := Dictionary newFrom: { #number-> 1 }.
	playground := Smalltalk tools workspace
		openContents: 'number + 1'.
	playground
		setBindings: wsBindings.! !

!GTPlayground class methodsFor: 'settings' stamp: 'TudorGirba 3/26/2015 00:37'!
extentSettingsOn: aBuilder 
	<systemsettings>
	
	(aBuilder setting: #GTPlaygroundPreferredWidth)
		target: self;
		parent: #gt;
		getSelector: #preferredWidth;
		setSelector: #preferredWidth:; 
		label: 'Playground width';
		description: 'The preferred width of new Playground windows'.
	(aBuilder setting: #GTPlaygroundPreferredHeight)
		target: self;
		parent: #gt;
		getSelector: #preferredHeight;
		setSelector: #preferredHeight:; 
		label: 'Playground height';
		description: 'The preferred height of new Playground windows'.
	(aBuilder setting: #GTPlaygroundRememberPreferredExtent)
		target: self;
		parent: #gt;
		getSelector: #rememberPreferredExtent;
		setSelector: #rememberPreferredExtent:; 
		label: 'Remember extent of Playground';
		description: 'Enable or disable remembering of the extent of Playground windows on resize. When the preference is true, resizing a Playground window will affect the preferred width and height of future Playground windows'.
	


! !

!GTPlayground class methodsFor: 'settings' stamp: 'AndreiChis 8/29/2014 00:39'!
isGTPlaygroundEnabled

	^ GTPlaygroundEnabledStatus ifNil: [ GTPlaygroundEnabledStatus := Smalltalk tools workspace = self ]! !

!GTPlayground class methodsFor: 'instance creation' stamp: 'TudorGirba 3/25/2015 22:41'!
open
	"self open"
	| page |
	page := GTPlayPage new.
	^ self openOn: page! !

!GTPlayground class methodsFor: 'instance creation' stamp: 'TudorGirba 3/25/2015 22:41'!
openContents: aString
	"Open a new playground with the given contents. aString has to be Smalltalk code. The style is applied"
	

	| page |
	
	page := GTPlayPage new
		saveContent: aString;
		yourself.
	^ self openOn: page! !

!GTPlayground class methodsFor: 'instance creation' stamp: 'TudorGirba 3/25/2015 22:41'!
openContents: aString label: aLabel
	"Open a new playground with the given contents"

	| page |

	page := GTPlayPage new
		saveContent: aString;
		title: aLabel;
		yourself.
	^ self openOn: page! !

!GTPlayground class methodsFor: 'compatibility-tools' stamp: 'TudorGirba 3/25/2015 22:41'!
openLabel: aLabel
	| page |

	page := GTPlayPage new
		title: aLabel;
		yourself.
	^ self openOn: page! !

!GTPlayground class methodsFor: 'settings' stamp: 'TudorGirba 3/25/2015 22:18'!
preferredExtent
	^ PreferredExtent ifNil: [ PreferredExtent := 600@400 ]! !

!GTPlayground class methodsFor: 'settings' stamp: 'TudorGirba 3/25/2015 22:16'!
preferredExtent: aPoint
	PreferredExtent := aPoint! !

!GTPlayground class methodsFor: 'settings' stamp: 'TudorGirba 3/25/2015 23:02'!
preferredHeight
	^ self preferredExtent y! !

!GTPlayground class methodsFor: 'settings' stamp: 'TudorGirba 3/25/2015 23:05'!
preferredHeight: aHeight
	self preferredExtent setX: self preferredExtent x setY: aHeight! !

!GTPlayground class methodsFor: 'settings' stamp: 'TudorGirba 3/25/2015 23:02'!
preferredWidth
	^ self preferredExtent x! !

!GTPlayground class methodsFor: 'settings' stamp: 'TudorGirba 3/25/2015 23:04'!
preferredWidth: aWidth
	self preferredExtent setX: aWidth setY: self preferredExtent y! !

!GTPlayground class methodsFor: 'tools registry' stamp: 'AndreiChis 8/28/2014 21:33'!
register

	self registerToolsOn: Smalltalk tools! !

!GTPlayground class methodsFor: 'tools registry' stamp: 'TudorGirba 2/9/2014 01:10'!
registerToolsOn: registry
	"Add ourselves to registry. See [Smalltalk tools]"
	"self registerToolsOn: Smalltalk tools" 
	registry register: self as: #workspace
! !

!GTPlayground class methodsFor: 'settings' stamp: 'TudorGirba 3/25/2015 22:55'!
rememberPreferredExtent
	^ RememberPreferredExtent ifNil: [ RememberPreferredExtent := true ]! !

!GTPlayground class methodsFor: 'settings' stamp: 'TudorGirba 3/25/2015 23:02'!
rememberPreferredExtent: aBoolean
	^ RememberPreferredExtent := aBoolean! !

!GTPlayground class methodsFor: 'settings' stamp: 'AndreiChis 8/28/2014 21:33'!
setGTPlaygroundEnabledStatus: aBoolean
	| oldStatus |
	
	oldStatus := self isGTPlaygroundEnabled.
	GTPlaygroundEnabledStatus := aBoolean.
	oldStatus ~= GTPlaygroundEnabledStatus ifTrue: [ 
		GTPlaygroundEnabledStatus 
			ifTrue: [ self register ]
			ifFalse: [ Workspace registerToolsOn: Smalltalk tools ] ]
	
	! !

!GTPlayground class methodsFor: 'settings' stamp: 'TudorGirba 3/25/2015 22:54'!
setPreferredExtentIfWanted: anExtent
	self rememberPreferredExtent ifTrue: [ 
		self preferredExtent: anExtent ]! !

!GTPlayground class methodsFor: 'settings' stamp: 'TudorGirba 3/26/2015 00:37'!
settingsOn: aBuilder 
	<systemsettings>
	
	(aBuilder setting: #GTPlaygroundStatus)
		target: self;
		parent: #gt;
		getSelector: #isGTPlaygroundEnabled;
		setSelector: #setGTPlaygroundEnabledStatus:; 
		label: 'GTPlayground';
		description: 'Enable or disable the GTPlayground.'.
	(aBuilder setting: #customDirectory)
		parent: #gt;
		type: #Directory;
		target: GTPlayBook;
		description: 'The path to the local Playground cache that stores all Playground scripts in ph files' translated;
		label: 'Local Playground cache directory'! !

!GTPlayground class methodsFor: 'tools registry' stamp: 'TudorGirba 2/11/2014 22:23'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^ Smalltalk ui icons iconNamed: #workspaceIcon! !

!GTPlayground class methodsFor: 'instance creation' stamp: 'TudorGirba 3/15/2015 21:49'!
title
	^ 'Playground'! !

!GTPlayground methodsFor: 'accessing' stamp: 'AndreiChis 9/8/2014 23:02'!
acceptAction: anAction
	"acceptAction := anAction."! !

!GTPlayground methodsFor: 'accessing' stamp: 'AndreiChis 9/30/2014 20:46'!
acceptContents: aString

	^ (self entity acceptContents: aString)
		ifTrue: [  
			self update.
			true]! !

!GTPlayground methodsFor: 'building' stamp: 'StefanReichhart 3/22/2015 21:32'!
actionsForPreviousContents
	^ GTPlayBook instance pagesSorted
		collect: [ :each | 
			GLMGenericAction new
				title: (each content asString contractTo: 50);
				action: [ :text | 
					text entity saveContent: each content.
					text update ];
				yourself ]! !

!GTPlayground methodsFor: 'building' stamp: 'AliakseiSyrel 3/27/2015 02:32'!
codeIn: a
	^ a pharoPlayground
		title: [ self newEditableLabelMorph ];
		format: [ :page | page content ];
		act: [ :text :page |
				text selectionInterval: (1 to: text text size).
				text highlightEvaluateAndDo: [ :result | text selection: result ] ]
			icon: GLMUIThemeExtraIcons glamorousGo
			on: $G
			entitled: 'Do it all and go';
		installGoAction;
		installDefaultSelectionActions;
		act: [ :text :page | page publish ]
			icon: GLMUIThemeExtraIcons glamorousSaveToUrl
			entitled: 'Remote publish';
		addAction: 
			((GLMPopupAction new) 
				action: [ :text :page :popup |
					|adaptor|
					adaptor := GLMBrickListAdaptor new on: self currentBindings associations.
					adaptor morphAtLogic: [ :index | self newBindingRowFor: (adaptor origin at: index) ].
					popup contentBrick paddingTop: 0; paddingBottom: 0.
					popup doNotHideUnhover.
					GLMFallbackScrollListBrick new
						scrollpaneBackgroundColor: Color transparent;
						emptyBrick: (GLMLabelBrick new
							text: 'No bindings';
							hSpaceFill;
							padding: #(15 10);
							textPosition: #center;
							textColor: Color gray;
							fontSize: 13;
							yourself);
						adaptor: adaptor;
						height: [ :b | b band height ];
						maxHeight: 300;
						width: 300
					
				]; 
				icon: GLMUIThemeExtraIcons glamorousBrowse;
				title: 'bindings';
				yourself);
		dynamicActions: [ self actionsForPreviousContents ];
		onChangeOfPort: #text act: [ :text :page | page saveContent: text text ]! !

!GTPlayground methodsFor: 'building' stamp: 'AndreiChis 3/26/2015 14:33'!
compose
	self title: self defaultPlaygroundTitle.
	self act: [ :browser | browser currentBindings inspect ] entitled: 'Inspect variables'.
	self act: [ :browser | browser resetBindings ] entitled: 'Reset variables'.
	self custom:
			(GTInspector new
				noTitle; 
				noActions;
				showFirst: [ :composite |
					self codeIn: composite ];
				yourself);
		on: GLMBrowserClosing do: [ 
			"This is a hack for the moment.
			We need a better mechanism from Glamour to help 
			us keep the model in sync"
			self entity
					saveContent: self first panes first presentations first text.
			GTPlayBook instance addPageIfInteresting: self entity ]! !

!GTPlayground methodsFor: 'accessing-dynamic' stamp: 'AndreiChis 3/19/2015 17:49'!
currentBindings 

	^ self inspectorPresentation firstPresentation currentBindings! !

!GTPlayground methodsFor: 'accessing-defaults' stamp: 'AndreiChis 3/25/2015 15:41'!
defaultPlaygroundTitle
	^ 'Playground'! !

!GTPlayground methodsFor: 'accessing-dynamic' stamp: 'AndreiChis 1/30/2015 11:35'!
inspectorPresentation

	^ self presentations first ! !

!GTPlayground methodsFor: 'accessing' stamp: 'AndreiChis 1/9/2015 11:17'!
label: aString
	"Set the window label to the given string"
	self title: aString.
	self update! !

!GTPlayground methodsFor: 'building' stamp: 'AliakseiSyrel 3/27/2015 02:36'!
newBindingRowFor: anAssociation
	|row name value action|
	
	row := GLMInteractableBrick new.
	row
		enable;
		selectedColor: (Color veryVeryLightGray alpha: 0.5);
		vShrinkWrap;
		hSpaceFill;
		padding: #( 5 0 6 0 );
		borderColor: Color veryLightGray;
		borderWidth: #( 0 0 1 0).
		
	name := GLMLabelBrick new.
	name
		hSpaceFill: 50;
		vShrinkWrap;
		textPosition: #leftCenter;
		vAlign: #center;
		padding: #(0 5);
		textColor: Color gray;
		borderColor: Color veryVeryLightGray;
		borderWidth: #(0 0 0 0);
		text: anAssociation key.
		
	value := GLMLabelBrick new.
	value
		hSpaceFill: 50;
		vShrinkWrap;
		textPosition: #leftCenter;
		vAlign: #center;
		borderColor: Color veryVeryLightGray;
		borderWidth: #(0 0 0 0);
		padding: #(0 5);
		text: anAssociation value asString.
		
	action := GLMHintableActionButtonBrick new.
	action
		padding: #(3 3);
		margin: #(0 3);
		marginRight: 6;
		hShrinkWrap;
		pressedColor: Color veryVeryLightGray;
		icon: GLMUIThemeExtraIcons glamorousClose;
		hintTitle: 'Remove binding';
		action: [
			|bindings|
			bindings := self currentBindings copy.
			bindings removeKey: anAssociation key ifAbsent: [ ].
			self setBindings: bindings.
			row owner scrollpane adaptor on: bindings associations.
			row owner scrollpane invalidate ];
		hintText: 'will completely unassign variable'.
		
	row addAllBricks: { name . value . action }.
	
	^ row
		
! !

!GTPlayground methodsFor: 'building' stamp: 'AndreiChis 3/26/2015 14:23'!
newEditableLabelMorph
	| hPadding |
	
	hPadding := 5.
	^ GLMEditableLabelBrick new
		hSpaceFill;
		text: self entity title;
		with: [ :label | label when: #onAccepted do: [ self entity title: label text ] ];
		cancelOnEscape;
		cancelOnFocusLost;
		with: [ :b | b margin: { b themer focusedBorderWidth . 0 } ];
		with: [ :b | b editBrick
			hShrinkWrap;
			rubricBackgroundColor: b themer rubricBackgroundColor;
			margins: (hPadding@0 corner: hPadding@0) ];
		with: [ :b | b maxWidth: [ b approximateWidth + b owner hPadding] ];
		with: [ :b | b labelBrick margin: { 0 . hPadding + 2. 0 . hPadding } ];
		with: [ :b | b layout widthDependency: [ b owner ] ];
		with: [ :b | b editBrick layout widthDependency: [ b ] ];
		yourself ! !

!GTPlayground methodsFor: 'scripting opening' stamp: 'TudorGirba 3/25/2015 22:54'!
openOn: aPage
	| window |
	window := super openOn: aPage.
	window extent: self class preferredExtent.
	window when: WindowResizing do: [ 
		self class setPreferredExtentIfWanted: window extent ].
	^ window! !

!GTPlayground methodsFor: 'actions' stamp: 'AndreiChis 3/19/2015 17:52'!
resetBindings

	^ self inspectorPresentation firstPresentation resetBindings! !

!GTPlayground methodsFor: 'actions' stamp: 'AndreiChis 1/30/2015 11:42'!
setBindings: aDictionary

	self inspectorPresentation firstPresentation 
		variableBindings: [ aDictionary associations ];
		updateVariableBindings! !

!RxMatcher methodsFor: '*GT-Playground' stamp: 'StefanReichhart 3/21/2015 09:52'!
matchesIn: aString subexpressionsDo: aBlock
	self matchesOnStream: aString readStream subexpressionsDo: aBlock! !

!RxMatcher methodsFor: '*GT-Playground' stamp: 'StefanReichhart 3/21/2015 09:51'!
matchesOnStream: aStream subexpressionsDo: aBlock
	| subexpressions |
	[ self searchStream: aStream ] whileTrue: [ 
		subexpressions := ((1 to: self subexpressionCount) collect: [ :each | (self subexpression: each) ]).
		aBlock value: subexpressions first value: subexpressions allButFirst ]! !

Object subclass: #GTPlayBook
	instanceVariableNames: 'pages pagesLimit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Playground'!

GTPlayBook class
	instanceVariableNames: 'instance cacheDirectory customDirectory'!

!GTPlayBook commentStamp: 'TudorGirba 10/22/2014 07:51' prior: 0!
This class holds the pages that are loaded in the image.

At class initialization time, it loads pages from the cacheDirectory and then maintains the pages in memory.!

GTPlayBook class
	instanceVariableNames: 'instance cacheDirectory customDirectory'!

!GTPlayBook class methodsFor: 'private' stamp: 'StefanReichhart 3/22/2015 14:27'!
basicEnsureDistinctDirectory: aStringOrFileReference
	" Ensure aStringOrFileReference is either nil or a valid file-reference object distinct from the default one.
	  Do not create any directory on disk yet - the first access to any directory will handle that.
	  #asFileReference and #absolutePath may raise anError!! "
	
	| fileReference |
	fileReference := aStringOrFileReference asFileReference.
	^ fileReference absolutePath = self defaultDirectory absolutePath
		ifTrue: [ nil ]
		ifFalse: [ fileReference ]
		
	" Background: The behavior of the default directory is being relative to the image. Therefore the default file-reference is relative to the image. If the image is moved/copied around the file-reference will stay relative to the image. We assume this is the expected behavior for the default directory. Therefore we prevent the user from setting that value as an absolute file-reference, since an absolute file-reference would behave differently when an image is moved/copied around. "! !

!GTPlayBook class methodsFor: 'accessing' stamp: 'StefanReichhart 3/22/2015 13:44'!
cacheDirectory
	" lazy initialize the cache and always ensure its existence - especially while the image is running "
	
	cacheDirectory ifNil: [ cacheDirectory := self defaultCacheDirectory ].
	^ cacheDirectory exists
		ifTrue: [ cacheDirectory ]
		ifFalse: [ cacheDirectory ensureCreateDirectory ]! !

!GTPlayBook class methodsFor: 'accessing' stamp: 'StefanReichhart 3/22/2015 13:44'!
cacheDirectory: aStringOrFileReference

	cacheDirectory := self ensureDistinctDirectory: aStringOrFileReference! !

!GTPlayBook class methodsFor: 'private' stamp: 'AndreiChis 3/25/2015 16:19'!
cleanUp
	
	self reset! !

!GTPlayBook class methodsFor: 'accessing' stamp: 'StefanReichhart 3/22/2015 13:44'!
customDirectory
	" the settings-browser will hang if this method returns nil or an object not being aFileReference " 
	
	^ customDirectory ifNil: [ self defaultCustomDirectory ]! !

!GTPlayBook class methodsFor: 'accessing' stamp: 'StefanReichhart 3/22/2015 13:44'!
customDirectory: aStringOrFileReference

	customDirectory := self ensureDistinctDirectory: aStringOrFileReference.
	cacheDirectory := nil.! !

!GTPlayBook class methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 3/22/2015 13:25'!
defaultCacheDirectory
	^ customDirectory ifNil: [ self defaultDirectory ]! !

!GTPlayBook class methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 3/22/2015 13:23'!
defaultCustomDirectory
	^ self defaultDirectory! !

!GTPlayBook class methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 3/22/2015 13:26'!
defaultDirectory
	^ 'play-cache/' asFileReference! !

!GTPlayBook class methodsFor: 'private' stamp: 'StefanReichhart 3/22/2015 14:25'!
ensureDistinctDirectory: aStringOrFileReference
	^ [ self basicEnsureDistinctDirectory: aStringOrFileReference ]
		on: Error
		do: [ nil ]! !

!GTPlayBook class methodsFor: 'examples' stamp: 'AndreiChis 3/26/2015 00:11'!
gtExampleEmpty
	<gtExample: 'Empty'>
	^ self new! !

!GTPlayBook class methodsFor: 'initializing' stamp: 'StefanReichhart 3/22/2015 13:43'!
initialize
	" we have to make sure the cached references are up-to-date after the image starts up "
	
	Smalltalk addToStartUpList: self! !

!GTPlayBook class methodsFor: 'accessing' stamp: 'TudorGirba 10/18/2014 21:48'!
instance
	^ instance ifNil: [ instance := self new ]! !

!GTPlayBook class methodsFor: 'private' stamp: 'TudorGirba 10/19/2014 21:34'!
reset
	
	instance := nil! !

!GTPlayBook class methodsFor: 'private' stamp: 'StefanReichhart 3/22/2015 13:43'!
resetDirectories

	cacheDirectory := nil.
	customDirectory := nil! !

!GTPlayBook class methodsFor: 'initializing' stamp: 'StefanReichhart 3/22/2015 13:43'!
startUp

	cacheDirectory := nil.! !

!GTPlayBook class methodsFor: 'initializing' stamp: 'StefanReichhart 3/22/2015 13:43'!
startUp: resuming

	cacheDirectory := nil.! !

!GTPlayBook methodsFor: 'actions' stamp: 'StefanReichhart 3/21/2015 09:37'!
addPage: aPage
	self pages addFirst: aPage! !

!GTPlayBook methodsFor: 'actions' stamp: 'StefanReichhart 3/20/2015 22:48'!
addPageIfInteresting: aPage
	aPage isInteresting ifFalse: [ ^ self ].
	self addPage: aPage! !

!GTPlayBook methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 3/20/2015 22:40'!
allFiles
	^ self class cacheDirectory files select: [ :each | 
		each extension = GTPlayPage fileExtension ]! !

!GTPlayBook methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 3/21/2015 09:38'!
allFilesSorted
	^ self allFiles sorted: [ :a :b | 
		a modificationTime > b modificationTime ]! !

!GTPlayBook methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 3/20/2015 22:45'!
defaultPages
	^ OrderedCollection new! !

!GTPlayBook methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 3/21/2015 09:47'!
defaultPagesLimit
	" page list in ui might get too long / holding too many object might decrease performance "
	^ 100! !

!GTPlayBook methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 3/21/2015 09:36'!
files
	^ self allFilesSorted takeFirst: self pagesLimit! !

!GTPlayBook methodsFor: 'ui' stamp: 'StefanReichhart 3/21/2015 09:39'!
gtPagesIn: composite
	<gtInspectorPresentationOrder: 0>
	composite list 
		title: 'Pages';
		display: [ self pages ];
		format: #gtDisplayString;
		filterOn: [ :text :each | text match: each content ]! !

!GTPlayBook methodsFor: 'initializing' stamp: 'StefanReichhart 3/21/2015 09:36'!
initialize
	self flag: 'error handling'.
	
	self pages: self defaultPages.
	self files do: [ :each | 
		[ self pages add: (GTPlayPage fromFileReference: each) ] " bypass "
			on: Error 
			do: [ " unhandled exceptions are bad design - we should handle it somehow " ] ]! !

!GTPlayBook methodsFor: 'accessing' stamp: 'StefanReichhart 3/20/2015 22:45'!
pages
	^ pages ifNil: [ pages := self defaultPages ]! !

!GTPlayBook methodsFor: 'accessing' stamp: 'TudorGirba 10/18/2014 21:49'!
pages: anObject
	pages := anObject! !

!GTPlayBook methodsFor: 'accessing' stamp: 'StefanReichhart 3/20/2015 22:34'!
pagesLimit
	^ pagesLimit ifNil: [ self defaultPagesLimit ]! !

!GTPlayBook methodsFor: 'accessing' stamp: 'StefanReichhart 3/20/2015 22:33'!
pagesLimit: anObject
	pagesLimit := anObject! !

!GTPlayBook methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 3/21/2015 09:38'!
pagesSorted
	^ self pages sorted: [ :a :b | 
		a modificationTime > b modificationTime ]! !

!GTPlayBook methodsFor: 'actions' stamp: 'StefanReichhart 3/21/2015 09:48'!
removePage: aPage
	self pages remove: aPage ifAbsent: [ " ignore if aPage is not registered " ]! !

Object subclass: #GTPlayPage
	instanceVariableNames: 'title content fileName creationTime modificationTime publishedUrl'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Playground'!

!GTPlayPage commentStamp: 'TudorGirba 10/22/2014 07:52' prior: 0!
It holds one page of code. It is the model behind the Playground.

It also knows how to store itself on disk, and every time its content changes, it updates the corresponding file.!

!GTPlayPage class methodsFor: 'private' stamp: 'StefanReichhart 3/22/2015 21:27'!
basicLoadFromPublishUrl: aString
	^ GTPlayPage new 
		publishedUrl: aString;
		saveContent: (GTUrlProvider new get: aString)
		yourself! !

!GTPlayPage class methodsFor: 'instance creation' stamp: 'StefanReichhart 3/20/2015 23:43'!
creationTimeFrom: aFileReference
	^ [ self creationTimeFromString: aFileReference basenameWithoutExtension ] 
		on: Error 
		do: [ aFileReference creationTime ]! !

!GTPlayPage class methodsFor: 'instance creation' stamp: 'StefanReichhart 3/21/2015 09:50'!
creationTimeFromString: aString
	" this is really ugly, but hopefully only a temporary solution untill we come up with somthing more reliable and more beautiful "
	| subexpressions |
	subexpressions := OrderedCollection new.
	'(\d+)-(\d+)-(\d+)T(\d+)-(\d+)-(\d+)(-(\d+))?([-+]\d+)-(\d+)(-(\d+))?' asRegex 
		matchesIn: aString
		subexpressionsDo: [ :expression :expressionFragments | 
			subexpressions addAll: (expressionFragments collect: [ :each | 
				[ each squeezeOutNumber ] on: Error do: [ 0 ] ]) ].
	^ DateAndTime 
		year: subexpressions first 
		month: subexpressions second 
		day: subexpressions third 
		hour: subexpressions fourth 
		minute: subexpressions fifth 
		second: subexpressions sixth 
		nanoSecond: subexpressions eighth * 100000 " 7 == full match "
		offset: (Duration 
						days: 0 
						hours: subexpressions ninth 
						minutes: (subexpressions at: 10) 
						seconds: (subexpressions at: 12)) " 11 == full match "! !

!GTPlayPage class methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 3/20/2015 22:31'!
fileExtension
	^ 'ph'! !

!GTPlayPage class methodsFor: 'instance creation' stamp: 'AndreiChis 3/25/2015 14:45'!
fromFileReference: aFileReference
	^ self new 
		fileName: aFileReference basename;
		content: (aFileReference readStreamDo: #contents); 
		creationTime: (self creationTimeFrom: aFileReference);
		modificationTime: aFileReference modificationTime;
		yourself! !

!GTPlayPage class methodsFor: 'examples' stamp: 'AndreiChis 3/26/2015 00:11'!
gtExampleEmpty
	<gtExample: 'Empty'>
	^ self new! !

!GTPlayPage class methodsFor: 'instance creation' stamp: 'StefanReichhart 3/20/2015 18:58'!
loadFromPublishUrl: aString
	^ [ self basicLoadFromPublishUrl: aString ] 
		on: Error 
		do: [ nil ]! !

!GTPlayPage class methodsFor: 'instance creation' stamp: 'StefanReichhart 3/20/2015 18:59'!
loadFromPublishUrl: aString thenDo: aBlock
	| page |
	page := self loadFromPublishUrl: aString.
	page ifNotNil: [ aBlock value: page ].
	^ page! !

!GTPlayPage methodsFor: 'compatibility-tools' stamp: 'StefanReichhart 3/21/2015 09:45'!
acceptContents: aStringOrtext

	self flag: #TODO. "Need support for what lies in the comment down here"
	"self fileName ifNotNil: [ self saveString: aStringOrtext toFile: self fileName ].

	acceptAction ifNotNil:[acceptAction value: aStringOrtext]."
	self saveContent: aStringOrtext.
	^ true! !

!GTPlayPage methodsFor: 'compatibility-tools' stamp: 'StefanReichhart 3/20/2015 22:10'!
cacheDirectory
	self deprecated: 'use: #fileDirectory instead'.
	^ self fileDirectory! !

!GTPlayPage methodsFor: 'accessing' stamp: 'StefanReichhart 3/22/2015 15:04'!
content
	" lazy for better backward/forward-compatibility "
	^ content ifNil: [ self defaultContent ]! !

!GTPlayPage methodsFor: 'accessing' stamp: 'StefanReichhart 3/20/2015 22:06'!
content: aString
	content := aString! !

!GTPlayPage methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 3/21/2015 09:46'!
contentString
	" strange, sometimes #content is aText not aString !! "
	^ self content asString! !

!GTPlayPage methodsFor: 'accessing' stamp: 'StefanReichhart 3/21/2015 09:41'!
creationTime
	" lazy for better backward/forward-compatibility "
	^ creationTime ifNil: [ creationTime := self defaultCreationTime ]! !

!GTPlayPage methodsFor: 'accessing' stamp: 'StefanReichhart 3/20/2015 21:49'!
creationTime: anObject
	creationTime := anObject! !

!GTPlayPage methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 3/20/2015 21:52'!
defaultContent
	^ ''! !

!GTPlayPage methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 3/20/2015 21:54'!
defaultCreationTime
	^ self defaultTimestamp! !

!GTPlayPage methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 3/20/2015 23:00'!
defaultFileName
	^ self title , '.' , self fileExtension! !

!GTPlayPage methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 3/20/2015 21:54'!
defaultModificationTime
	^ self creationTime! !

!GTPlayPage methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 3/22/2015 21:31'!
defaultPublishedUrl
	^ ''! !

!GTPlayPage methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 3/20/2015 21:51'!
defaultTimestamp
	^ DateAndTime now! !

!GTPlayPage methodsFor: 'accessing-defaults' stamp: 'AndreiChis 3/25/2015 16:55'!
defaultTitle
	^ 'Untitled'
	"^ (self creationTime asString copyReplaceAll: ':' with: '-') copyReplaceAll: '.' with: '-'"! !

!GTPlayPage methodsFor: 'private' stamp: 'StefanReichhart 3/20/2015 22:18'!
deleteFromFileSystem
	self fileReference ensureDelete! !

!GTPlayPage methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 3/20/2015 22:09'!
fileDirectory
	^ GTPlayBook cacheDirectory! !

!GTPlayPage methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 3/20/2015 22:31'!
fileExtension
	^ self class fileExtension! !

!GTPlayPage methodsFor: 'accessing' stamp: 'StefanReichhart 3/21/2015 09:41'!
fileName
	" lazy for better backward/forward-compatibility "
	^ fileName ifNil: [ fileName := self defaultFileName ]! !

!GTPlayPage methodsFor: 'accessing' stamp: 'StefanReichhart 3/20/2015 23:00'!
fileName: anObject
	fileName := anObject! !

!GTPlayPage methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 3/20/2015 22:09'!
fileReference
	^ self fileDirectory / self fileName! !

!GTPlayPage methodsFor: 'ui' stamp: 'StefanReichhart 3/21/2015 09:44'!
gtDisplayOn: stream
	stream nextPutAll: (self contentString copyReplaceAll: String cr with: String space)! !

!GTPlayPage methodsFor: 'ui' stamp: 'TudorGirba 11/2/2014 22:14'!
gtInspectorContentIn: composite
	<gtInspectorPresentationOrder: 0>
	composite pharoPlayground 
		title: 'Content';
		display: #content;
		installGoAction;
		installDefaultSelectionActions! !

!GTPlayPage methodsFor: 'initializing' stamp: 'StefanReichhart 3/21/2015 09:43'!
initialize
	super initialize.
	
	self content: self defaultContent.
	self creationTime: self defaultCreationTime.
	self modificationTime: self defaultModificationTime! !

!GTPlayPage methodsFor: 'testing' stamp: 'StefanReichhart 3/21/2015 09:44'!
isInteresting
	^ self contentString trimBoth isEmpty not! !

!GTPlayPage methodsFor: 'accessing' stamp: 'StefanReichhart 3/21/2015 09:41'!
modificationTime
	" lazy for better backward/forward-compatibility "
	^ modificationTime ifNil: [ modificationTime := self defaultModificationTime ]! !

!GTPlayPage methodsFor: 'accessing' stamp: 'TudorGirba 3/15/2015 23:24'!
modificationTime: anObject
	modificationTime := anObject! !

!GTPlayPage methodsFor: 'actions' stamp: 'StefanReichhart 3/22/2015 21:28'!
publish
	(self confirm: 'Publish playground content to the cloud?')
        ifFalse: [ ^ self ].
    self content ifEmpty: [ 
        self inform: 'Nothing was published because the playground is empty'.
        ^ self ].
    Clipboard clipboardText: (publishedUrl := (GTUrlProvider new post: self contentString) asString).
    self inform: publishedUrl , ' was published and the url was copied to clipboard'! !

!GTPlayPage methodsFor: 'accessing' stamp: 'StefanReichhart 3/22/2015 21:27'!
publishedUrl
	^ publishedUrl ifNil: [ self defaultPublishedUrl ]! !

!GTPlayPage methodsFor: 'accessing' stamp: 'StefanReichhart 3/22/2015 21:27'!
publishedUrl: anObject
	publishedUrl := anObject! !

!GTPlayPage methodsFor: 'actions' stamp: 'StefanReichhart 3/20/2015 22:17'!
save
	self content isEmpty
		ifTrue: [ self deleteFromFileSystem ]
		ifFalse: [ self writeToFileSystem ]! !

!GTPlayPage methodsFor: 'actions' stamp: 'StefanReichhart 3/21/2015 00:18'!
saveContent: aStringOrText
	self modificationTime: self defaultTimestamp.
	self content: aStringOrText.
	self save.! !

!GTPlayPage methodsFor: 'compatibility-tools' stamp: 'StefanReichhart 3/21/2015 09:45'!
silentContent: aStringOrtext
	self deprecated: 'use: #content: instead (has no side-effects)'.
	self content: aStringOrtext! !

!GTPlayPage methodsFor: 'accessing-dynamic' stamp: 'AndreiChis 3/25/2015 16:49'!
title
	^ title ifNil: [ self defaultTitle ]! !

!GTPlayPage methodsFor: 'accessing-dynamic' stamp: 'AndreiChis 3/25/2015 16:49'!
title: aString
	title := aString! !

!GTPlayPage methodsFor: 'private' stamp: 'StefanReichhart 3/21/2015 09:44'!
writeToFileSystem
	self fileReference writeStreamDo: [ :stream | 
		stream 
			truncate; 
			nextPutAll: self contentString ]! !

Object subclass: #GTUrlProvider
	instanceVariableNames: 'urlProvider'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Playground'!

GTUrlProvider class
	instanceVariableNames: 'urlProvider'!

!GTUrlProvider commentStamp: 'TudorGirba 10/22/2014 07:50' prior: 0!
This class was inspired from the Zinc SharedWorkspace project.

Its job is to work with a UrlProvider that can provide (via get) and store (via post) strings.!

GTUrlProvider class
	instanceVariableNames: 'urlProvider'!

!GTUrlProvider class methodsFor: 'settings' stamp: 'TudorGirba 10/22/2014 08:02'!
settingsOn: aBuilder 
	<systemsettings>
	
	(aBuilder setting: #stringUrlProvider)
		parent: #gt;
		target: self;
		description: 'The url for the script sharing service like the one from http://ws.stfx.eu' translated;
		label: 'The url for the script sharing service'
! !

!GTUrlProvider class methodsFor: 'accessing' stamp: 'TudorGirba 10/22/2014 08:02'!
stringUrlProvider
	^ self urlProvider asString! !

!GTUrlProvider class methodsFor: 'accessing' stamp: 'TudorGirba 10/22/2014 08:01'!
stringUrlProvider: aString
	self urlProvider: aString! !

!GTUrlProvider class methodsFor: 'accessing' stamp: 'TudorGirba 10/22/2014 07:48'!
urlProvider
	^ urlProvider ifNil: [ urlProvider := 'http://ws.stfx.eu' asZnUrl ]! !

!GTUrlProvider class methodsFor: 'accessing' stamp: 'TudorGirba 10/22/2014 07:48'!
urlProvider: aUrlObject
	urlProvider := aUrlObject ifNotNil: [ aUrlObject asZnUrl ]! !

!GTUrlProvider methodsFor: 'public' stamp: 'TudorGirba 10/22/2014 07:50'!
get: url	
	| contents |
	contents := self httpClient get: url.
	^ String new: contents size streamContents: [ :stream |
		contents linesDo: [ :each | stream nextPutAll: each; cr ] ]! !

!GTUrlProvider methodsFor: 'private' stamp: 'TudorGirba 10/22/2014 07:47'!
httpClient
	^ ZnClient new
		systemPolicy;
		beOneShot;
		accept: ZnMimeType textPlain;
		url: self urlProvider;
		yourself! !

!GTUrlProvider methodsFor: 'public' stamp: 'TudorGirba 10/22/2014 07:53'!
post: string
	| entity client url |
	entity := ZnEntity text: string asString.
	(client := self httpClient)
		entity: entity; 
		post.
	url := client response location.
	^ url asZnUrl inContextOf: self urlProvider ! !

!GTUrlProvider methodsFor: 'public' stamp: 'TudorGirba 10/22/2014 07:49'!
urlProvider
	^ urlProvider ifNil: [ urlProvider := self class urlProvider ]! !

!GTUrlProvider methodsFor: 'initialize-release' stamp: 'TudorGirba 10/22/2014 07:49'!
urlProvider: anUrlObject
	urlProvider := anUrlObject asZnUrl ! !
GTPlayBook initialize!
